import _ from 'underscore';
import getProperty from '../get-by-path/get-property.js';
import setProperty from './set-property.js';

import { isModel } from 'bbmn-core';
export default function setByPathArr(context, propertyName, pathArray, value, options) {

	let modelContext;
	if (isModel(context)) {
		modelContext = {
			model: context,
			property: propertyName,
			pathChunks: [].slice.call(pathArray)
		};
	}

	//set value if this is a last chunk of path
	if (!pathArray.length) {

		modelContext && options.models.push(modelContext);

		return {			
			value: setProperty(context, propertyName, value, options)
		};

	} else {

		var prop = getProperty(context, propertyName);

		if (!_.isObject(prop) && !options.force) {
			return;
		} else if (!_.isObject(prop) && options.force) {
			prop = setProperty(context, propertyName, {}, options);
		} 

		modelContext && options.models.push(modelContext);

		var nextName = pathArray.shift();

		return setByPathArr(prop, nextName, pathArray, value, options);

	}
}
